<?php

/*

cleantalk_post() process phpBB 3 posts to detect SPAM and offtopic.
Copyright (C) 2011 Denis Shagimuratov shagimuratov@cleantalk.ru

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

if (!defined('IN_PHPBB'))
{
   exit;
}

function ct_error_mail($response){
	
	global $config, $user, $phpbb_root_path, $phpEx;

	if (!function_exists('phpbb_mail'))
	{
		include($phpbb_root_path . 'includes/functions_messenger.' . $phpEx);
	}
	
	$headers[] = 'Reply-To: ' . $config['board_email'];
	$headers[] = 'Return-Path: <' . $config['board_email'] . '>';
	$headers[] = 'Sender: <' . $config['board_email'] . '>';
	$headers[] = 'MIME-Version: 1.0';
	$headers[] = 'X-Mailer: phpBB3';
	$headers[] = 'X-MimeOLE: phpBB3';
	$headers[] = 'X-phpBB-Origin: phpbb://' . str_replace(array('http://', 'https://'), array('', ''), generate_board_url());
	$headers[] = 'Content-Type: text/plain; charset=UTF-8'; // format=flowed
	$headers[] = 'Content-Transfer-Encoding: 8bit'; // 7bit

	$err_msg = '';
	$err_str = sprintf($user->lang['CT_ERROR'], $response->faultString(), $config['ct_server_url']);
	$result = @phpbb_mail($config['board_email'], $config['ct_server_url'], $err_str, $headers, "\n", &$err_msg);

	if (!$result)
	{
		$this->error('EMAIL', $err_msg);
		return false;
	}
		
	return 1;
}

function cleantalk_post($message, $forum_id, $topic_id, $response, $username, $enable_stoplist_check){
	
	global $db, $config, $user, $phpEx, $phpbb_root_path;

	$ct_example = ''; // Example text 
	$ct_url = ''; // Post URL
	
	if($topic_id == 0) // First post in topic
	{ 				
		$sql = 'SELECT p.post_text FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TABLE . ' p, ' . FORUMS_TABLE . ' f 
			WHERE t.forum_id = f.forum_id and 
			p.forum_id = f.forum_id and p.topic_id = t.topic_id and p.post_id = t.topic_first_post_id and
			p.post_approved = 1 and f.forum_id = ' . (int) $forum_id . ' ORDER BY p.post_time desc';
		$result = $db->sql_query_limit($sql, $config['ct_post_count']);
		while ($row = $db->sql_fetchrow($result))
		{
			$ct_example .= $row['post_text'] . "<br />";
		}
		$db->sql_freeresult($result);
	}
	else
	{
		$sql = 'SELECT topic_title, topic_first_post_id FROM ' . TOPICS_TABLE . ' WHERE topic_id = ' . (int) $topic_id;
		$result = $db->sql_query($sql);
		$sql_result = $db->sql_fetchrow($result);
		$topic_title = $sql_result['topic_title'];
		$topic_first_post_id = $sql_result['topic_first_post_id'];
		$db->sql_freeresult($result);

		$sql = 'SELECT post_text FROM ' . POSTS_TABLE . ' WHERE post_id = ' . (int) $topic_first_post_id;
		$result = $db->sql_query($sql);
		$sql_result = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		
		$ct_example = $topic_title . "<br />" . $sql_result['post_text'] . "<br />";

		$sql = 'SELECT post_id,post_text FROM ' . POSTS_TABLE . ' 
		WHERE topic_id = ' . (int) $topic_id . ' and post_id <> '. (int) $topic_first_post_id . ' and 
		post_approved = 1 ORDER BY post_time desc';
		$result = $db->sql_query_limit($sql, $config['ct_post_count']);
		while ($row = $db->sql_fetchrow($result))
		{
			$ct_example .= $row['post_text'] . "<br />";
		}
		$db->sql_freeresult($result);
	}
	
	if (!isset($ct))
	{
		if (!class_exists('Cleantalk'))
		{
			include($phpbb_root_path . 'includes/cleantalk.class.' . $phpEx);
		}
		$ct = new Cleantalk(array(
			'auth_key' => $config['ct_auth_key'],
			'server_url' => $config['ct_server_url'],
			'response_lang' => $config['ct_response_lang']
		));
	}	
	$params = array(
		'message' => $message,
		'base_text' => $ct_example,
		'engine' => $config['ct_agent'],
		'url' => $ct_url,
		'stoplist_check' => $enable_stoplist_check,
		'session_ip' => ct_session_ip($user->data['session_ip']), 
		'user_email' => $user->data['user_email'],
		'user_name' => $username
	);
	
	if (!$ct->isAllowMessage($params, &$response))
	{
		ct_error_mail($response);
		$response = null; // Because is object 
		$response['allow'] = 0; // Send message to moderate queue			
		return 0;
	}
		
	return 1;
}

/*
	Get user IP
*/
function ct_session_ip($data_ip){
	$forwarded_for = htmlspecialchars((string) $_SERVER['HTTP_X_FORWARDED_FOR']); 
	// 127.0.0.1 usually used at reverse proxy
	$session_ip = ($data_ip == '127.0.0.1' && !empty($forwarded_for)) ? $forwarded_for : $data_ip;
	
	return $session_ip; 
}

?>
